//: Playground - noun: a place where people can play

import Cocoa
import XCPlayground

//XCPSetExecutionShouldContinueIndefinitely(true)
XCPlaygroundPage.currentPage.needsIndefiniteExecution = true

// -- Format Specifier

var value = 3.14159265
// Double als String mit zwei Nachkommastellen
var t2 = String(format: "%.2f", value)
// Double als String mit vier Nachkommastellen
var t4 = String(format: "%.4f", value)

var index = 100
// Int als String mit zusätzlichem Text
var i = String(format: "Der Wert ist: %i", index)

var a1 = 45.2354
var a2 = 67.8823
// Umwandlung mehrerer Werte
var z = String(
    format: "%.2f + %.2f ist %.2f.", a1, a2, a1+a2)

var firstName = "Lisa"
var lastName = "Lee"
var name = String(format: "%@ %@", firstName, lastName)

var byte = 255
// Umwandlung von 255 in "FF"
var bUppercase = String(format: "%X", byte)
// Umwandlung von 255 in "ff"
var bLowercase = String(format: "%x", byte)

// Umwandlung von true in "1"
var expression = true
var e = String(format: "%@", expression)

// - Funktionen

// Eine Funktion, die einen Parameter entgegennimmt,
// aber keinen Wert zurückgibt
func outputValue(value:Double)
{
    print("Der Wert ist: \(value)")
}

// Funktionsaufruf
outputValue(67.42)

// Eine Funktion, die zwei Parameter entgegennimmt
// und einen Wert zurückgibt
func addValues(value1:Double, value2:Double) -> Double
{
    return value1 + value2
}

// Funktionsaufruf
var result = addValues(55.22, value2:99.11)

// Eine Funktion, die keine Parameter entgegennimmt
// und einen Tupel zurückgibt
func getDummyName() -> (firstname:String, lastName:String)
{
    return ("Max", "Müller")
}

// Funktionsaufruf und Ausgabe
var max = getDummyName()
print("\(max.firstname) \(max.lastName)")

// -- Grand Central Dispatch

// Warteschlange vom System anfordern
let queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT,0)

// Closure-Block der Warteschlange hinzufügen und ausführen
dispatch_async(queue)
    {
        var sum = 0.0;
        for var i = 1 ; i < 1000 ; i++
        {
            sum = sum + Double(i)
        }
        print("Die Summe ist: \(sum)")
}










